package com.sample.ikna.app;

import com.sample.ikna.entity.study.Deck;
import io.jmix.core.DataManager;
import io.jmix.data.event.EntityChangedEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.event.TransactionPhase;
import org.springframework.transaction.event.TransactionalEventListener;

@Component
public class DeckEntityListener {

    @Autowired
    private DataManager dataManager;

    @TransactionalEventListener(phase = TransactionPhase.BEFORE_COMMIT)
    public void beforeCommit(EntityChangedEvent<Deck> event) {
        Deck deck = dataManager.load(event.getEntityId()).one();
        if (deck.getAverageRating() == null) {
            deck.setAverageRating(0.0);
            dataManager.save(deck);
        }
    }
}
