package com.sample.ikna.entity;

import com.sample.ikna.entity.billing.CardDetails;
import io.jmix.core.entity.annotation.EmbeddedParameters;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.time.OffsetDateTime;

@Table(name = "IKNA_PREMIUM_USER", indexes = {
        @Index(name = "IDX_PREMIUM_USER_BY_USER_ID", columnList = "USER_ID", unique = true)
})
@Entity(name = "ikna_PremiumUser")
@DiscriminatorValue("P")
@PrimaryKeyJoinColumn(name = "USER_ID", referencedColumnName = "ID")
public class PremiumUser extends User {
    private static final long serialVersionUID = 672686944504647731L;

    @Column(name = "SUBSCRIPTION_END_DATE")
    private OffsetDateTime subscriptionEndDate;

    @Embedded
    @EmbeddedParameters(nullAllowed = false)
    @AttributeOverrides({
            @AttributeOverride(name = "brand", column = @Column(name = "CARD_BRAND")),
            @AttributeOverride(name = "lastFourDigits", column = @Column(name = "CARD_LAST_4_DIGITS")),
            @AttributeOverride(name = "expiryDate", column = @Column(name = "CARD_EXPIRY_DATE")),
            @AttributeOverride(name = "holderName", column = @Column(name = "CARD_HOLDER_NAME")),
            @AttributeOverride(name = "paymentGateToken", column = @Column(name = "CARD_PAYMENT_GATE_TOKEN"))
    })
    private CardDetails cardDetails;

    @NotNull
    @Column(name = "EMAIL_NOTIFICATIONS_ENABLED", nullable = false)
    private Boolean emailNotificationsEnabled = false;

    @NotNull
    @Column(name = "SLACK_NOTIFICATIONS_ENABLED", nullable = false)
    private Boolean slackNotificationsEnabled = false;

    @Column(name = "SLACK_ACCESS_TOKEN")
    private String slackAccessToken;

    @Column(name = "AVATAR")
    private byte[] avatar;

    public CardDetails getCardDetails() {
        return cardDetails;
    }

    public void setCardDetails(CardDetails cardDetails) {
        this.cardDetails = cardDetails;
    }

    public void setAvatar(byte[] avatar) {
        this.avatar = avatar;
    }

    public byte[] getAvatar() {
        return avatar;
    }


    public String getSlackAccessToken() {
        return slackAccessToken;
    }

    public void setSlackAccessToken(String slackAccessToken) {
        this.slackAccessToken = slackAccessToken;
    }

    public Boolean getSlackNotificationsEnabled() {
        return slackNotificationsEnabled;
    }

    public void setSlackNotificationsEnabled(Boolean slackNotificationsEnabled) {
        this.slackNotificationsEnabled = slackNotificationsEnabled;
    }

    public Boolean getEmailNotificationsEnabled() {
        return emailNotificationsEnabled;
    }

    public void setEmailNotificationsEnabled(Boolean emailNotificationsEnabled) {
        this.emailNotificationsEnabled = emailNotificationsEnabled;
    }

    public OffsetDateTime getSubscriptionEndDate() {
        return subscriptionEndDate;
    }

    public void setSubscriptionEndDate(OffsetDateTime subscriptionEndDate) {
        this.subscriptionEndDate = subscriptionEndDate;
    }
}