package com.sample.ikna.entity.stats;

import com.sample.ikna.entity.User;
import com.sample.ikna.entity.study.Deck;
import io.jmix.core.entity.annotation.SystemLevel;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.ModelProperty;
import io.jmix.core.metamodel.annotation.Store;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@Store(name = "stats")
@Table(name = "IKNA_DECK_STUDY_STATE")
@Entity(name = "ikna_DeckStudyState")
public class DeckStudyState {
    private static final long serialVersionUID = 0L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "ID", nullable = false)
    private Long id;

    @NotNull
    @SystemLevel
    @Column(name = "USER_ID", nullable = false)
    private UUID userId;

    @NotNull
    @SystemLevel
    @Column(name = "DECK_ID", nullable = false)
    private Long deckId;

    @Transient
    @ModelProperty(mandatory = true)
    @DependsOnProperties("deckId")
    private Deck deck;

    @Transient
    @ModelProperty(mandatory = true)
    @DependsOnProperties("userId")
    private User user;

    public Long getDeckId() {
        return deckId;
    }

    public void setDeckId(Long deckId) {
        this.deckId = deckId;
    }

    public UUID getUserId() {
        return userId;
    }

    public void setUserId(UUID userId) {
        this.userId = userId;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Deck getDeck() {
        return deck;
    }

    public void setDeck(Deck deck) {
        this.deck = deck;
    }


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
}